0bb4eb54dea1bf987ea3fdf30bd1d110030d42e3
[csit.git] / resources / libraries / bash / function / common.sh
1 # Copyright (c) 2020 Cisco and/or its affiliates.
2 # Copyright (c) 2020 PANTHEON.tech and/or its affiliates.
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a copy of the License at:
6 #
7 #     http://www.apache.org/licenses/LICENSE-2.0
8 #
9 # Unless required by applicable law or agreed to in writing, software
10 # distributed under the License is distributed on an "AS IS" BASIS,
11 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12 # See the License for the specific language governing permissions and
13 # limitations under the License.
14
15 set -exuo pipefail
16
17 # This library defines functions used by multiple entry scripts.
18 # Keep functions ordered alphabetically, please.
19
20 # TODO: Add a link to bash style guide.
21 # TODO: Consider putting every die into a {} block,
22 #   the code might become more readable (but longer).
23
24
25 function activate_docker_topology () {
26
27     # Create virtual vpp-device topology. Output of the function is topology
28     # file describing created environment saved to a file.
29     #
30     # Variables read:
31     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
32     # - TOPOLOGIES - Available topologies.
33     # - NODENESS - Node multiplicity of desired testbed.
34     # - FLAVOR - Node flavor string, usually describing the processor.
35     # - IMAGE_VER_FILE - Name of file that contains the image version.
36     # - CSIT_DIR - Directory where ${IMAGE_VER_FILE} is located.
37     # Variables set:
38     # - WORKING_TOPOLOGY - Path to topology file.
39
40     set -exuo pipefail
41
42     source "${BASH_FUNCTION_DIR}/device.sh" || {
43         die "Source failed!"
44     }
45     device_image="$(< ${CSIT_DIR}/${IMAGE_VER_FILE})"
46     case_text="${NODENESS}_${FLAVOR}"
47     case "${case_text}" in
48         "1n_skx" | "1n_tx2")
49             # We execute reservation over csit-shim-dcr (ssh) which runs sourced
50             # script's functions. Env variables are read from ssh output
51             # back to localhost for further processing.
52             # Shim and Jenkins executor are in the same network on the same host
53             # Connect to docker's default gateway IP and shim's exposed port
54             ssh="ssh root@172.17.0.1 -p 6022"
55             run="activate_wrapper ${NODENESS} ${FLAVOR} ${device_image}"
56             # The "declare -f" output is long and boring.
57             set +x
58             # backtics to avoid https://midnight-commander.org/ticket/2142
59             env_vars=`${ssh} "$(declare -f); ${run}"` || {
60                 die "Topology reservation via shim-dcr failed!"
61             }
62             set -x
63             set -a
64             source <(echo "$env_vars" | grep -v /usr/bin/docker) || {
65                 die "Source failed!"
66             }
67             set +a
68             ;;
69         "1n_vbox")
70             # We execute reservation on localhost. Sourced script automatially
71             # sets environment variables for further processing.
72             activate_wrapper "${NODENESS}" "${FLAVOR}" "${device_image}" || die
73             ;;
74         *)
75             die "Unknown specification: ${case_text}!"
76     esac
77
78     trap 'deactivate_docker_topology' EXIT || {
79          die "Trap attempt failed, please cleanup manually. Aborting!"
80     }
81
82     # Replace all variables in template with those in environment.
83     source <(echo 'cat <<EOF >topo.yml'; cat ${TOPOLOGIES[0]}; echo EOF;) || {
84         die "Topology file create failed!"
85     }
86
87     WORKING_TOPOLOGY="/tmp/topology.yaml"
88     mv topo.yml "${WORKING_TOPOLOGY}" || {
89         die "Topology move failed!"
90     }
91     cat ${WORKING_TOPOLOGY} | grep -v password || {
92         die "Topology read failed!"
93     }
94 }
95
96
97 function activate_virtualenv () {
98
99     # Update virtualenv pip package, delete and create virtualenv directory,
100     # activate the virtualenv, install requirements, set PYTHONPATH.
101
102     # Arguments:
103     # - ${1} - Path to existing directory for creating virtualenv in.
104     #          If missing or empty, ${CSIT_DIR} is used.
105     # - ${2} - Path to requirements file, ${CSIT_DIR}/requirements.txt if empty.
106     # Variables read:
107     # - CSIT_DIR - Path to existing root of local CSIT git repository.
108     # Variables exported:
109     # - PYTHONPATH - CSIT_DIR, as CSIT Python scripts usually need this.
110     # Functions called:
111     # - die - Print to stderr and exit.
112
113     set -exuo pipefail
114
115     root_path="${1-$CSIT_DIR}"
116     env_dir="${root_path}/env"
117     req_path=${2-$CSIT_DIR/requirements.txt}
118     rm -rf "${env_dir}" || die "Failed to clean previous virtualenv."
119     pip3 install virtualenv==20.0.20 || {
120         die "Virtualenv package install failed."
121     }
122     virtualenv --no-download --python=$(which python3) "${env_dir}" || {
123         die "Virtualenv creation for $(which python3) failed."
124     }
125     set +u
126     source "${env_dir}/bin/activate" || die "Virtualenv activation failed."
127     set -u
128     pip3 install -r "${req_path}" || {
129         die "Requirements installation failed."
130     }
131     # Most CSIT Python scripts assume PYTHONPATH is set and exported.
132     export PYTHONPATH="${CSIT_DIR}" || die "Export failed."
133 }
134
135
136 function archive_tests () {
137
138     # Create .tar.xz of generated/tests for archiving.
139     # To be run after generate_tests, kept separate to offer more flexibility.
140
141     # Directory read:
142     # - ${GENERATED_DIR}/tests - Tree of executed suites to archive.
143     # File rewriten:
144     # - ${ARCHIVE_DIR}/tests.tar.xz - Archive of generated tests.
145
146     set -exuo pipefail
147
148     tar c "${GENERATED_DIR}/tests" | xz -3 > "${ARCHIVE_DIR}/tests.tar.xz" || {
149         die "Error creating archive of generated tests."
150     }
151 }
152
153
154 function check_download_dir () {
155
156     # Fail if there are no files visible in ${DOWNLOAD_DIR}.
157     #
158     # Variables read:
159     # - DOWNLOAD_DIR - Path to directory pybot takes the build to test from.
160     # Directories read:
161     # - ${DOWNLOAD_DIR} - Has to be non-empty to proceed.
162     # Functions called:
163     # - die - Print to stderr and exit.
164
165     set -exuo pipefail
166
167     if [[ ! "$(ls -A "${DOWNLOAD_DIR}")" ]]; then
168         die "No artifacts downloaded!"
169     fi
170 }
171
172
173 function check_prerequisites () {
174
175     # Fail if prerequisites are not met.
176     #
177     # Functions called:
178     # - installed - Check if application is installed/present in system.
179     # - die - Print to stderr and exit.
180
181     set -exuo pipefail
182
183     if ! installed sshpass; then
184         die "Please install sshpass before continue!"
185     fi
186 }
187
188
189 function common_dirs () {
190
191     # Set global variables, create some directories (without touching content).
192
193     # Variables set:
194     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
195     # - CSIT_DIR - Path to existing root of local CSIT git repository.
196     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
197     # - JOB_SPECS_DIR - Path to existing directory with job test specifications.
198     # - RESOURCES_DIR - Path to existing CSIT subdirectory "resources".
199     # - TOOLS_DIR - Path to existing resources subdirectory "tools".
200     # - PYTHON_SCRIPTS_DIR - Path to existing tools subdirectory "scripts".
201     # - ARCHIVE_DIR - Path to created CSIT subdirectory "archives".
202     #   The name is chosen to match what ci-management expects.
203     # - DOWNLOAD_DIR - Path to created CSIT subdirectory "download_dir".
204     # - GENERATED_DIR - Path to created CSIT subdirectory "generated".
205     # Directories created if not present:
206     # ARCHIVE_DIR, DOWNLOAD_DIR, GENERATED_DIR.
207     # Functions called:
208     # - die - Print to stderr and exit.
209
210     set -exuo pipefail
211
212     this_file=$(readlink -e "${BASH_SOURCE[0]}") || {
213         die "Some error during locating of this source file."
214     }
215     BASH_FUNCTION_DIR=$(dirname "${this_file}") || {
216         die "Some error during dirname call."
217     }
218     # Current working directory could be in a different repo, e.g. VPP.
219     pushd "${BASH_FUNCTION_DIR}" || die "Pushd failed"
220     relative_csit_dir=$(git rev-parse --show-toplevel) || {
221         die "Git rev-parse failed."
222     }
223     CSIT_DIR=$(readlink -e "${relative_csit_dir}") || die "Readlink failed."
224     popd || die "Popd failed."
225     TOPOLOGIES_DIR=$(readlink -e "${CSIT_DIR}/topologies/available") || {
226         die "Readlink failed."
227     }
228     JOB_SPECS_DIR=$(readlink -e "${CSIT_DIR}/docs/job_specs") || {
229         die "Readlink failed."
230     }
231     RESOURCES_DIR=$(readlink -e "${CSIT_DIR}/resources") || {
232         die "Readlink failed."
233     }
234     TOOLS_DIR=$(readlink -e "${RESOURCES_DIR}/tools") || {
235         die "Readlink failed."
236     }
237     DOC_GEN_DIR=$(readlink -e "${TOOLS_DIR}/doc_gen") || {
238         die "Readlink failed."
239     }
240     PYTHON_SCRIPTS_DIR=$(readlink -e "${TOOLS_DIR}/scripts") || {
241         die "Readlink failed."
242     }
243
244     ARCHIVE_DIR=$(readlink -f "${CSIT_DIR}/archives") || {
245         die "Readlink failed."
246     }
247     mkdir -p "${ARCHIVE_DIR}" || die "Mkdir failed."
248     DOWNLOAD_DIR=$(readlink -f "${CSIT_DIR}/download_dir") || {
249         die "Readlink failed."
250     }
251     mkdir -p "${DOWNLOAD_DIR}" || die "Mkdir failed."
252     GENERATED_DIR=$(readlink -f "${CSIT_DIR}/generated") || {
253         die "Readlink failed."
254     }
255     mkdir -p "${GENERATED_DIR}" || die "Mkdir failed."
256 }
257
258
259 function compose_pybot_arguments () {
260
261     # Variables read:
262     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
263     # - DUT - CSIT test/ subdirectory, set while processing tags.
264     # - TAGS - Array variable holding selected tag boolean expressions.
265     # - TOPOLOGIES_TAGS - Tag boolean expression filtering tests for topology.
266     # - TEST_CODE - The test selection string from environment or argument.
267     # - SELECTION_MODE - Selection criteria [test, suite, include, exclude].
268     # Variables set:
269     # - PYBOT_ARGS - String holding part of all arguments for pybot.
270     # - EXPANDED_TAGS - Array of strings pybot arguments compiled from tags.
271
272     set -exuo pipefail
273
274     # No explicit check needed with "set -u".
275     PYBOT_ARGS=("--loglevel" "TRACE")
276     PYBOT_ARGS+=("--variable" "TOPOLOGY_PATH:${WORKING_TOPOLOGY}")
277
278     case "${TEST_CODE}" in
279         *"device"*)
280             PYBOT_ARGS+=("--suite" "tests.${DUT}.device")
281             ;;
282         *"perf"*)
283             PYBOT_ARGS+=("--suite" "tests.${DUT}.perf")
284             ;;
285         *)
286             die "Unknown specification: ${TEST_CODE}"
287     esac
288
289     EXPANDED_TAGS=()
290     for tag in "${TAGS[@]}"; do
291         if [[ ${tag} == "!"* ]]; then
292             EXPANDED_TAGS+=("--exclude" "${tag#$"!"}")
293         else
294             EXPANDED_TAGS+=("${SELECTION_MODE}" "${tag}")
295         fi
296     done
297
298     EXPANDED_TAGS+=("--include" "${TOPOLOGIES_TAGS}")
299 }
300
301
302 function deactivate_docker_topology () {
303
304     # Deactivate virtual vpp-device topology by removing containers.
305     #
306     # Variables read:
307     # - NODENESS - Node multiplicity of desired testbed.
308     # - FLAVOR - Node flavor string, usually describing the processor.
309
310     set -exuo pipefail
311
312     case_text="${NODENESS}_${FLAVOR}"
313     case "${case_text}" in
314         "1n_skx" | "1n_tx2")
315             ssh="ssh root@172.17.0.1 -p 6022"
316             env_vars=$(env | grep CSIT_ | tr '\n' ' ' ) || die
317             # The "declare -f" output is long and boring.
318             set +x
319             ${ssh} "$(declare -f); deactivate_wrapper ${env_vars}" || {
320                 die "Topology cleanup via shim-dcr failed!"
321             }
322             set -x
323             ;;
324         "1n_vbox")
325             enter_mutex || die
326             clean_environment || {
327                 die "Topology cleanup locally failed!"
328             }
329             exit_mutex || die
330             ;;
331         *)
332             die "Unknown specification: ${case_text}!"
333     esac
334 }
335
336
337 function die () {
338
339     # Print the message to standard error end exit with error code specified
340     # by the second argument.
341     #
342     # Hardcoded values:
343     # - The default error message.
344     # Arguments:
345     # - ${1} - The whole error message, be sure to quote. Optional
346     # - ${2} - the code to exit with, default: 1.
347
348     set -x
349     set +eu
350     warn "${1:-Unspecified run-time error occurred!}"
351     exit "${2:-1}"
352 }
353
354
355 function die_on_pybot_error () {
356
357     # Source this fragment if you want to abort on any failed test case.
358     #
359     # Variables read:
360     # - PYBOT_EXIT_STATUS - Set by a pybot running fragment.
361     # Functions called:
362     # - die - Print to stderr and exit.
363
364     set -exuo pipefail
365
366     if [[ "${PYBOT_EXIT_STATUS}" != "0" ]]; then
367         die "Test failures are present!" "${PYBOT_EXIT_STATUS}"
368     fi
369 }
370
371
372 function generate_tests () {
373
374     # Populate ${GENERATED_DIR}/tests based on ${CSIT_DIR}/tests/.
375     # Any previously existing content of ${GENERATED_DIR}/tests is wiped before.
376     # The generation is done by executing any *.py executable
377     # within any subdirectory after copying.
378
379     # This is a separate function, because this code is called
380     # both by autogen checker and entries calling run_pybot.
381
382     # Directories read:
383     # - ${CSIT_DIR}/tests - Used as templates for the generated tests.
384     # Directories replaced:
385     # - ${GENERATED_DIR}/tests - Overwritten by the generated tests.
386
387     set -exuo pipefail
388
389     rm -rf "${GENERATED_DIR}/tests" || die
390     cp -r "${CSIT_DIR}/tests" "${GENERATED_DIR}/tests" || die
391     cmd_line=("find" "${GENERATED_DIR}/tests" "-type" "f")
392     cmd_line+=("-executable" "-name" "*.py")
393     # We sort the directories, so log output can be compared between runs.
394     file_list=$("${cmd_line[@]}" | sort) || die
395
396     for gen in ${file_list}; do
397         directory="$(dirname "${gen}")" || die
398         filename="$(basename "${gen}")" || die
399         pushd "${directory}" || die
400         ./"${filename}" || die
401         popd || die
402     done
403 }
404
405
406 function get_test_code () {
407
408     # Arguments:
409     # - ${1} - Optional, argument of entry script (or empty as unset).
410     #   Test code value to override job name from environment.
411     # Variables read:
412     # - JOB_NAME - String affecting test selection, default if not argument.
413     # Variables set:
414     # - TEST_CODE - The test selection string from environment or argument.
415     # - NODENESS - Node multiplicity of desired testbed.
416     # - FLAVOR - Node flavor string, usually describing the processor.
417
418     set -exuo pipefail
419
420     TEST_CODE="${1-}" || die "Reading optional argument failed, somehow."
421     if [[ -z "${TEST_CODE}" ]]; then
422         TEST_CODE="${JOB_NAME-}" || die "Reading job name failed, somehow."
423     fi
424
425     case "${TEST_CODE}" in
426         *"1n-vbox"*)
427             NODENESS="1n"
428             FLAVOR="vbox"
429             ;;
430         *"1n-skx"*)
431             NODENESS="1n"
432             FLAVOR="skx"
433             ;;
434        *"1n-tx2"*)
435             NODENESS="1n"
436             FLAVOR="tx2"
437             ;;
438         *"2n-skx"*)
439             NODENESS="2n"
440             FLAVOR="skx"
441             ;;
442         *"2n-zn2"*)
443             NODENESS="2n"
444             FLAVOR="zn2"
445             ;;
446         *"3n-skx"*)
447             NODENESS="3n"
448             FLAVOR="skx"
449             ;;
450         *"2n-clx"*)
451             NODENESS="2n"
452             FLAVOR="clx"
453             ;;
454         *"2n-dnv"*)
455             NODENESS="2n"
456             FLAVOR="dnv"
457             ;;
458         *"3n-dnv"*)
459             NODENESS="3n"
460             FLAVOR="dnv"
461             ;;
462         *"2n-tx2"*)
463             NODENESS="2n"
464             FLAVOR="tx2"
465             ;;
466         *"3n-tsh"*)
467             NODENESS="3n"
468             FLAVOR="tsh"
469             ;;
470         *)
471             # Fallback to 3-node Haswell by default (backward compatibility)
472             NODENESS="3n"
473             FLAVOR="hsw"
474             ;;
475     esac
476 }
477
478
479 function get_test_tag_string () {
480
481     # Variables read:
482     # - GERRIT_EVENT_TYPE - Event type set by gerrit, can be unset.
483     # - GERRIT_EVENT_COMMENT_TEXT - Comment text, read for "comment-added" type.
484     # - TEST_CODE - The test selection string from environment or argument.
485     # Variables set:
486     # - TEST_TAG_STRING - The string following trigger word in gerrit comment.
487     #   May be empty, or even not set on event types not adding comment.
488
489     # TODO: ci-management scripts no longer need to perform this.
490
491     set -exuo pipefail
492
493     if [[ "${GERRIT_EVENT_TYPE-}" == "comment-added" ]]; then
494         case "${TEST_CODE}" in
495             *"device"*)
496                 trigger="devicetest"
497                 ;;
498             *"perf"*)
499                 trigger="perftest"
500                 ;;
501             *)
502                 die "Unknown specification: ${TEST_CODE}"
503         esac
504         # Ignore lines not containing the trigger word.
505         comment=$(fgrep "${trigger}" <<< "${GERRIT_EVENT_COMMENT_TEXT}" || true)
506         # The vpp-csit triggers trail stuff we are not interested in.
507         # Removing them and trigger word: https://unix.stackexchange.com/a/13472
508         # (except relying on \s whitespace, \S non-whitespace and . both).
509         # The last string is concatenated, only the middle part is expanded.
510         cmd=("grep" "-oP" '\S*'"${trigger}"'\S*\s\K.+$') || die "Unset trigger?"
511         # On parsing error, TEST_TAG_STRING probably stays empty.
512         TEST_TAG_STRING=$("${cmd[@]}" <<< "${comment}" || true)
513         if [[ -z "${TEST_TAG_STRING-}" ]]; then
514             # Probably we got a base64 encoded comment.
515             comment=$(base64 --decode <<< "${GERRIT_EVENT_COMMENT_TEXT}" || true)
516             comment=$(fgrep "${trigger}" <<< "${comment}" || true)
517             TEST_TAG_STRING=$("${cmd[@]}" <<< "${comment}" || true)
518         fi
519         if [[ -n "${TEST_TAG_STRING-}" ]]; then
520             test_tag_array=(${TEST_TAG_STRING})
521             if [[ "${test_tag_array[0]}" == "icl" ]]; then
522                 export GRAPH_NODE_VARIANT="icl"
523                 TEST_TAG_STRING="${test_tag_array[@]:1}" || true
524             elif [[ "${test_tag_array[0]}" == "skx" ]]; then
525                 export GRAPH_NODE_VARIANT="skx"
526                 TEST_TAG_STRING="${test_tag_array[@]:1}" || true
527             elif [[ "${test_tag_array[0]}" == "hsw" ]]; then
528                 export GRAPH_NODE_VARIANT="hsw"
529                 TEST_TAG_STRING="${test_tag_array[@]:1}" || true
530             fi
531         fi
532     fi
533 }
534
535
536 function installed () {
537
538     # Check if the given utility is installed. Fail if not installed.
539     #
540     # Duplicate of common.sh function, as this file is also used standalone.
541     #
542     # Arguments:
543     # - ${1} - Utility to check.
544     # Returns:
545     # - 0 - If command is installed.
546     # - 1 - If command is not installed.
547
548     set -exuo pipefail
549
550     command -v "${1}"
551 }
552
553
554 function move_archives () {
555
556     # Move archive directory to top of workspace, if not already there.
557     #
558     # ARCHIVE_DIR is positioned relative to CSIT_DIR,
559     # but in some jobs CSIT_DIR is not same as WORKSPACE
560     # (e.g. under VPP_DIR). To simplify ci-management settings,
561     # we want to move the data to the top. We do not want simple copy,
562     # as ci-management is eager with recursive search.
563     #
564     # As some scripts may call this function multiple times,
565     # the actual implementation use copying and deletion,
566     # so the workspace gets "union" of contents (except overwrites on conflict).
567     # The consequence is empty ARCHIVE_DIR remaining after this call.
568     #
569     # As the source directory is emptied,
570     # the check for dirs being different is essential.
571     #
572     # Variables read:
573     # - WORKSPACE - Jenkins workspace, move only if the value is not empty.
574     #   Can be unset, then it speeds up manual testing.
575     # - ARCHIVE_DIR - Path to directory with content to be moved.
576     # Directories updated:
577     # - ${WORKSPACE}/archives/ - Created if does not exist.
578     #   Content of ${ARCHIVE_DIR}/ is moved.
579     # Functions called:
580     # - die - Print to stderr and exit.
581
582     set -exuo pipefail
583
584     if [[ -n "${WORKSPACE-}" ]]; then
585         target=$(readlink -f "${WORKSPACE}/archives")
586         if [[ "${target}" != "${ARCHIVE_DIR}" ]]; then
587             mkdir -p "${target}" || die "Archives dir create failed."
588             cp -rf "${ARCHIVE_DIR}"/* "${target}" || die "Copy failed."
589             rm -rf "${ARCHIVE_DIR}"/* || die "Delete failed."
590         fi
591     fi
592 }
593
594
595 function reserve_and_cleanup_testbed () {
596
597     # Reserve physical testbed, perform cleanup, register trap to unreserve.
598     # When cleanup fails, remove from topologies and keep retrying
599     # until all topologies are removed.
600     #
601     # Variables read:
602     # - TOPOLOGIES - Array of paths to topology yaml to attempt reservation on.
603     # - PYTHON_SCRIPTS_DIR - Path to directory holding the reservation script.
604     # - BUILD_TAG - Any string suitable as filename, identifying
605     #   test run executing this function. May be unset.
606     # Variables set:
607     # - TOPOLOGIES - Array of paths to topologies, with failed cleanups removed.
608     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
609     # Functions called:
610     # - die - Print to stderr and exit.
611     # - ansible_playbook - Perform an action using ansible, see ansible.sh
612     # Traps registered:
613     # - EXIT - Calls cancel_all for ${WORKING_TOPOLOGY}.
614
615     set -exuo pipefail
616
617     while true; do
618         for topo in "${TOPOLOGIES[@]}"; do
619             set +e
620             scrpt="${PYTHON_SCRIPTS_DIR}/topo_reservation.py"
621             opts=("-t" "${topo}" "-r" "${BUILD_TAG:-Unknown}")
622             python3 "${scrpt}" "${opts[@]}"
623             result="$?"
624             set -e
625             if [[ "${result}" == "0" ]]; then
626                 # Trap unreservation before cleanup check,
627                 # so multiple jobs showing failed cleanup improve chances
628                 # of humans to notice and fix.
629                 WORKING_TOPOLOGY="${topo}"
630                 echo "Reserved: ${WORKING_TOPOLOGY}"
631                 trap "untrap_and_unreserve_testbed" EXIT || {
632                     message="TRAP ATTEMPT AND UNRESERVE FAILED, FIX MANUALLY."
633                     untrap_and_unreserve_testbed "${message}" || {
634                         die "Teardown should have died, not failed."
635                     }
636                     die "Trap attempt failed, unreserve succeeded. Aborting."
637                 }
638                 # Cleanup + calibration checks.
639                 set +e
640                 ansible_playbook "cleanup, calibration"
641                 result="$?"
642                 set -e
643                 if [[ "${result}" == "0" ]]; then
644                     break
645                 fi
646                 warn "Testbed cleanup failed: ${topo}"
647                 untrap_and_unreserve_testbed "Fail of unreserve after cleanup."
648             fi
649             # Else testbed is accessible but currently reserved, moving on.
650         done
651
652         if [[ -n "${WORKING_TOPOLOGY-}" ]]; then
653             # Exit the infinite while loop if we made a reservation.
654             warn "Reservation and cleanup successful."
655             break
656         fi
657
658         if [[ "${#TOPOLOGIES[@]}" == "0" ]]; then
659             die "Run out of operational testbeds!"
660         fi
661
662         # Wait ~3minutes before next try.
663         sleep_time="$[ ( ${RANDOM} % 20 ) + 180 ]s" || {
664             die "Sleep time calculation failed."
665         }
666         echo "Sleeping ${sleep_time}"
667         sleep "${sleep_time}" || die "Sleep failed."
668     done
669 }
670
671
672 function run_pybot () {
673
674     # Run pybot with options based on input variables. Create output_info.xml
675     #
676     # Variables read:
677     # - CSIT_DIR - Path to existing root of local CSIT git repository.
678     # - ARCHIVE_DIR - Path to store robot result files in.
679     # - PYBOT_ARGS, EXPANDED_TAGS - See compose_pybot_arguments.sh
680     # - GENERATED_DIR - Tests are assumed to be generated under there.
681     # Variables set:
682     # - PYBOT_EXIT_STATUS - Exit status of most recent pybot invocation.
683     # Functions called:
684     # - die - Print to stderr and exit.
685
686     set -exuo pipefail
687
688     all_options=("--outputdir" "${ARCHIVE_DIR}" "${PYBOT_ARGS[@]}")
689     all_options+=("--noncritical" "EXPECTED_FAILING")
690     all_options+=("${EXPANDED_TAGS[@]}")
691
692     pushd "${CSIT_DIR}" || die "Change directory operation failed."
693     set +e
694     robot "${all_options[@]}" "${GENERATED_DIR}/tests/"
695     PYBOT_EXIT_STATUS="$?"
696     set -e
697
698     # Generate INFO level output_info.xml for post-processing.
699     all_options=("--loglevel" "INFO")
700     all_options+=("--log" "none")
701     all_options+=("--report" "none")
702     all_options+=("--output" "${ARCHIVE_DIR}/output_info.xml")
703     all_options+=("${ARCHIVE_DIR}/output.xml")
704     rebot "${all_options[@]}" || true
705     popd || die "Change directory operation failed."
706 }
707
708
709 function select_arch_os () {
710
711     # Set variables affected by local CPU architecture and operating system.
712     #
713     # Variables set:
714     # - VPP_VER_FILE - Name of file in CSIT dir containing vpp stable version.
715     # - IMAGE_VER_FILE - Name of file in CSIT dir containing the image name.
716     # - PKG_SUFFIX - Suffix of OS package file name, "rpm" or "deb."
717
718     set -exuo pipefail
719
720     os_id=$(grep '^ID=' /etc/os-release | cut -f2- -d= | sed -e 's/\"//g') || {
721         die "Get OS release failed."
722     }
723
724     case "${os_id}" in
725         "ubuntu"*)
726             IMAGE_VER_FILE="VPP_DEVICE_IMAGE_UBUNTU"
727             VPP_VER_FILE="VPP_STABLE_VER_UBUNTU_BIONIC"
728             PKG_SUFFIX="deb"
729             ;;
730         "centos"*)
731             IMAGE_VER_FILE="VPP_DEVICE_IMAGE_CENTOS"
732             VPP_VER_FILE="VPP_STABLE_VER_CENTOS"
733             PKG_SUFFIX="rpm"
734             ;;
735         *)
736             die "Unable to identify distro or os from ${os_id}"
737             ;;
738     esac
739
740     arch=$(uname -m) || {
741         die "Get CPU architecture failed."
742     }
743
744     case "${arch}" in
745         "aarch64")
746             IMAGE_VER_FILE="${IMAGE_VER_FILE}_ARM"
747             ;;
748         *)
749             ;;
750     esac
751 }
752
753
754 function select_tags () {
755
756     # Variables read:
757     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
758     # - TEST_CODE - String affecting test selection, usually jenkins job name.
759     # - DUT - CSIT test/ subdirectory, set while processing tags.
760     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
761     #   Can be unset.
762     # - TOPOLOGIES_DIR - Path to existing directory with available tpologies.
763     # - BASH_FUNCTION_DIR - Directory with input files to process.
764     # Variables set:
765     # - TAGS - Array of processed tag boolean expressions.
766     # - SELECTION_MODE - Selection criteria [test, suite, include, exclude].
767
768     set -exuo pipefail
769
770     # NIC SELECTION
771     start_pattern='^  TG:'
772     end_pattern='^ \? \?[A-Za-z0-9]\+:'
773     # Remove the TG section from topology file
774     sed_command="/${start_pattern}/,/${end_pattern}/d"
775     # All topologies DUT NICs
776     available=$(sed "${sed_command}" "${TOPOLOGIES_DIR}"/* \
777                 | grep -hoP "model: \K.*" | sort -u)
778     # Selected topology DUT NICs
779     reserved=$(sed "${sed_command}" "${WORKING_TOPOLOGY}" \
780                | grep -hoP "model: \K.*" | sort -u)
781     # All topologies DUT NICs - Selected topology DUT NICs
782     exclude_nics=($(comm -13 <(echo "${reserved}") <(echo "${available}"))) || {
783         die "Computation of excluded NICs failed."
784     }
785
786     # Select default NIC tag.
787     case "${TEST_CODE}" in
788         *"3n-dnv"* | *"2n-dnv"*)
789             default_nic="nic_intel-x553"
790             ;;
791         *"3n-tsh"*)
792             default_nic="nic_intel-x520-da2"
793             ;;
794         *"3n-skx"* | *"2n-skx"* | *"2n-clx"* | *"2n-zn2"*)
795             default_nic="nic_intel-xxv710"
796             ;;
797         *"3n-hsw"* | *"2n-tx2"* | *"mrr-daily-master")
798             default_nic="nic_intel-xl710"
799             ;;
800         *)
801             default_nic="nic_intel-x710"
802             ;;
803     esac
804
805     sed_nic_sub_cmd="sed s/\${default_nic}/${default_nic}/"
806     awk_nics_sub_cmd=""
807     awk_nics_sub_cmd+='gsub("xxv710","25ge2p1xxv710");'
808     awk_nics_sub_cmd+='gsub("x710","10ge2p1x710");'
809     awk_nics_sub_cmd+='gsub("xl710","40ge2p1xl710");'
810     awk_nics_sub_cmd+='gsub("x520","10ge2p1x520");'
811     awk_nics_sub_cmd+='gsub("x553","10ge2p1x553");'
812     awk_nics_sub_cmd+='gsub("cx556a","10ge2p1cx556a");'
813     awk_nics_sub_cmd+='gsub("vic1227","10ge2p1vic1227");'
814     awk_nics_sub_cmd+='gsub("vic1385","10ge2p1vic1385");'
815     awk_nics_sub_cmd+='if ($9 =="drv_avf") drv="avf-";'
816     awk_nics_sub_cmd+='else if ($9 =="drv_rdma_core") drv ="rdma-";'
817     awk_nics_sub_cmd+='else drv="";'
818     awk_nics_sub_cmd+='print "*"$7"-" drv $11"-"$5"."$3"-"$1"-" drv $11"-"$5'
819
820     # Tag file directory shorthand.
821     tfd="${JOB_SPECS_DIR}"
822     case "${TEST_CODE}" in
823         # Select specific performance tests based on jenkins job type variable.
824         *"ndrpdr-weekly"* )
825             readarray -t test_tag_array <<< $(grep -v "#" \
826                 ${tfd}/mlr_weekly/${DUT}-${NODENESS}-${FLAVOR}.md |
827                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
828             SELECTION_MODE="--test"
829             ;;
830         *"mrr-daily"* )
831             readarray -t test_tag_array <<< $(grep -v "#" \
832                 ${tfd}/mrr_daily/${DUT}-${NODENESS}-${FLAVOR}.md |
833                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
834             SELECTION_MODE="--test"
835             ;;
836         *"mrr-weekly"* )
837             readarray -t test_tag_array <<< $(grep -v "#" \
838                 ${tfd}/mrr_weekly/${DUT}-${NODENESS}-${FLAVOR}.md |
839                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
840             SELECTION_MODE="--test"
841             ;;
842         *"report-iterative"* )
843             test_sets=(${TEST_TAG_STRING//:/ })
844             # Run only one test set per run
845             report_file=${test_sets[0]}.md
846             readarray -t test_tag_array <<< $(grep -v "#" \
847                 ${tfd}/report_iterative/${NODENESS}-${FLAVOR}/${report_file} |
848                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
849             SELECTION_MODE="--test"
850             ;;
851         *"report-coverage"* )
852             test_sets=(${TEST_TAG_STRING//:/ })
853             # Run only one test set per run
854             report_file=${test_sets[0]}.md
855             readarray -t test_tag_array <<< $(grep -v "#" \
856                 ${tfd}/report_coverage/${NODENESS}-${FLAVOR}/${report_file} |
857                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
858             SELECTION_MODE="--test"
859             ;;
860         * )
861             if [[ -z "${TEST_TAG_STRING-}" ]]; then
862                 # If nothing is specified, we will run pre-selected tests by
863                 # following tags.
864                 test_tag_array=("mrrAND${default_nic}AND1cAND64bANDip4base"
865                                 "mrrAND${default_nic}AND1cAND78bANDip6base"
866                                 "mrrAND${default_nic}AND1cAND64bANDl2bdbase"
867                                 "mrrAND${default_nic}AND1cAND64bANDl2xcbase"
868                                 "!dot1q" "!drv_avf")
869             else
870                 # If trigger contains tags, split them into array.
871                 test_tag_array=(${TEST_TAG_STRING//:/ })
872             fi
873             SELECTION_MODE="--include"
874             ;;
875     esac
876
877     # Blacklisting certain tags per topology.
878     #
879     # Reasons for blacklisting:
880     # - ipsechw - Blacklisted on testbeds without crypto hardware accelerator.
881     # TODO: Add missing reasons here (if general) or where used (if specific).
882     case "${TEST_CODE}" in
883         *"2n-skx"*)
884             test_tag_array+=("!ipsec")
885             ;;
886         *"3n-skx"*)
887             test_tag_array+=("!ipsechw")
888             # Not enough nic_intel-xxv710 to support double link tests.
889             test_tag_array+=("!3_node_double_link_topoANDnic_intel-xxv710")
890             ;;
891         *"2n-clx"*)
892             test_tag_array+=("!ipsec")
893             ;;
894         *"2n-zn2"*)
895             test_tag_array+=("!ipsec")
896             ;;
897         *"2n-dnv"*)
898             test_tag_array+=("!ipsechw")
899             test_tag_array+=("!memif")
900             test_tag_array+=("!srv6_proxy")
901             test_tag_array+=("!vhost")
902             test_tag_array+=("!vts")
903             test_tag_array+=("!drv_avf")
904             ;;
905         *"2n-tx2"*)
906             test_tag_array+=("!ipsechw")
907             ;;
908         *"3n-dnv"*)
909             test_tag_array+=("!memif")
910             test_tag_array+=("!srv6_proxy")
911             test_tag_array+=("!vhost")
912             test_tag_array+=("!vts")
913             test_tag_array+=("!drv_avf")
914             ;;
915         *"3n-tsh"*)
916             # 3n-tsh only has x520 NICs which don't work with AVF
917             test_tag_array+=("!drv_avf")
918             test_tag_array+=("!ipsechw")
919             ;;
920         *"3n-hsw"*)
921             test_tag_array+=("!drv_avf")
922             # All cards have access to QAT. But only one card (xl710)
923             # resides in same NUMA as QAT. Other cards must go over QPI
924             # which we do not want to even run.
925             test_tag_array+=("!ipsechwNOTnic_intel-xl710")
926             ;;
927         *)
928             # Default to 3n-hsw due to compatibility.
929             test_tag_array+=("!drv_avf")
930             test_tag_array+=("!ipsechwNOTnic_intel-xl710")
931             ;;
932     esac
933
934     # We will add excluded NICs.
935     test_tag_array+=("${exclude_nics[@]/#/!NIC_}")
936
937     TAGS=()
938     prefix=""
939
940     set +x
941     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
942         # Automatic prefixing for VPP jobs to limit the NIC used and
943         # traffic evaluation to MRR.
944         if [[ "${TEST_TAG_STRING-}" == *"nic_"* ]]; then
945             prefix="${prefix}mrrAND"
946         else
947             prefix="${prefix}mrrAND${default_nic}AND"
948         fi
949     fi
950     for tag in "${test_tag_array[@]}"; do
951         if [[ "${tag}" == "!"* ]]; then
952             # Exclude tags are not prefixed.
953             TAGS+=("${tag}")
954         elif [[ "${tag}" == " "* || "${tag}" == *"perftest"* ]]; then
955             # Badly formed tag expressions can trigger way too much tests.
956             set -x
957             warn "The following tag expression hints at bad trigger: ${tag}"
958             warn "Possible cause: Multiple triggers in a single comment."
959             die "Aborting to avoid triggering too many tests."
960         elif [[ "${tag}" == *"OR"* ]]; then
961             # If OR had higher precedence than AND, it would be useful here.
962             # Some people think it does, thus triggering way too much tests.
963             set -x
964             warn "The following tag expression hints at bad trigger: ${tag}"
965             warn "Operator OR has lower precedence than AND. Use space instead."
966             die "Aborting to avoid triggering too many tests."
967         elif [[ "${tag}" != "" && "${tag}" != "#"* ]]; then
968             # Empty and comment lines are skipped.
969             # Other lines are normal tags, they are to be prefixed.
970             TAGS+=("${prefix}${tag}")
971         fi
972     done
973     set -x
974 }
975
976
977 function select_topology () {
978
979     # Variables read:
980     # - NODENESS - Node multiplicity of testbed, either "2n" or "3n".
981     # - FLAVOR - Node flavor string, currently either "hsw" or "skx".
982     # - CSIT_DIR - Path to existing root of local CSIT git repository.
983     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
984     # Variables set:
985     # - TOPOLOGIES - Array of paths to suitable topology yaml files.
986     # - TOPOLOGIES_TAGS - Tag expression selecting tests for the topology.
987     # Functions called:
988     # - die - Print to stderr and exit.
989
990     set -exuo pipefail
991
992     case_text="${NODENESS}_${FLAVOR}"
993     case "${case_text}" in
994         # TODO: Move tags to "# Blacklisting certain tags per topology" section.
995         # TODO: Double link availability depends on NIC used.
996         "1n_vbox")
997             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
998             TOPOLOGIES_TAGS="2_node_single_link_topo"
999             ;;
1000         "1n_skx" | "1n_tx2")
1001             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
1002             TOPOLOGIES_TAGS="2_node_single_link_topo"
1003             ;;
1004         "2n_skx")
1005             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_skx*.yaml )
1006             TOPOLOGIES_TAGS="2_node_*_link_topo"
1007             ;;
1008         "2n_zn2")
1009             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_zn2*.yaml )
1010             TOPOLOGIES_TAGS="2_node_*_link_topo"
1011             ;;
1012         "3n_skx")
1013             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_skx*.yaml )
1014             TOPOLOGIES_TAGS="3_node_*_link_topo"
1015             ;;
1016         "2n_clx")
1017             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_clx*.yaml )
1018             TOPOLOGIES_TAGS="2_node_*_link_topo"
1019             ;;
1020         "2n_dnv")
1021             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_dnv*.yaml )
1022             TOPOLOGIES_TAGS="2_node_single_link_topo"
1023             ;;
1024         "3n_dnv")
1025             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_dnv*.yaml )
1026             TOPOLOGIES_TAGS="3_node_single_link_topo"
1027             ;;
1028         "3n_hsw")
1029             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_hsw*.yaml )
1030             TOPOLOGIES_TAGS="3_node_single_link_topo"
1031             ;;
1032         "3n_tsh")
1033             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_tsh*.yaml )
1034             TOPOLOGIES_TAGS="3_node_single_link_topo"
1035             ;;
1036         "2n_tx2")
1037             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_tx2*.yaml )
1038             TOPOLOGIES_TAGS="2_node_single_link_topo"
1039             ;;
1040         *)
1041             # No falling back to 3n_hsw default, that should have been done
1042             # by the function which has set NODENESS and FLAVOR.
1043             die "Unknown specification: ${case_text}"
1044     esac
1045
1046     if [[ -z "${TOPOLOGIES-}" ]]; then
1047         die "No applicable topology found!"
1048     fi
1049 }
1050
1051
1052 function select_vpp_device_tags () {
1053
1054     # Variables read:
1055     # - TEST_CODE - String affecting test selection, usually jenkins job name.
1056     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
1057     #   Can be unset.
1058     # Variables set:
1059     # - TAGS - Array of processed tag boolean expressions.
1060
1061     set -exuo pipefail
1062
1063     case "${TEST_CODE}" in
1064         # Select specific device tests based on jenkins job type variable.
1065         * )
1066             if [[ -z "${TEST_TAG_STRING-}" ]]; then
1067                 # If nothing is specified, we will run pre-selected tests by
1068                 # following tags. Items of array will be concatenated by OR
1069                 # in Robot Framework.
1070                 test_tag_array=()
1071             else
1072                 # If trigger contains tags, split them into array.
1073                 test_tag_array=(${TEST_TAG_STRING//:/ })
1074             fi
1075             ;;
1076     esac
1077
1078     # Blacklisting certain tags per topology.
1079     #
1080     # Reasons for blacklisting:
1081     # - avf - AVF is not possible to run on enic driver of VirtualBox.
1082     # - vhost - VirtualBox does not support nesting virtualization on Intel CPU.
1083     case "${TEST_CODE}" in
1084         *"1n-vbox"*)
1085             test_tag_array+=("!avf")
1086             test_tag_array+=("!vhost")
1087             ;;
1088         *)
1089             ;;
1090     esac
1091
1092     TAGS=()
1093
1094     # We will prefix with devicetest to prevent running other tests
1095     # (e.g. Functional).
1096     prefix="devicetestAND"
1097     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
1098         # Automatic prefixing for VPP jobs to limit testing.
1099         prefix="${prefix}"
1100     fi
1101     for tag in "${test_tag_array[@]}"; do
1102         if [[ ${tag} == "!"* ]]; then
1103             # Exclude tags are not prefixed.
1104             TAGS+=("${tag}")
1105         else
1106             TAGS+=("${prefix}${tag}")
1107         fi
1108     done
1109 }
1110
1111 function untrap_and_unreserve_testbed () {
1112
1113     # Use this as a trap function to ensure testbed does not remain reserved.
1114     # Perhaps call directly before script exit, to free testbed for other jobs.
1115     # This function is smart enough to avoid multiple unreservations (so safe).
1116     # Topo cleanup is executed (call it best practice), ignoring failures.
1117     #
1118     # Hardcoded values:
1119     # - default message to die with if testbed might remain reserved.
1120     # Arguments:
1121     # - ${1} - Message to die with if unreservation fails. Default hardcoded.
1122     # Variables read (by inner function):
1123     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
1124     # - PYTHON_SCRIPTS_DIR - Path to directory holding Python scripts.
1125     # Variables written:
1126     # - WORKING_TOPOLOGY - Set to empty string on successful unreservation.
1127     # Trap unregistered:
1128     # - EXIT - Failure to untrap is reported, but ignored otherwise.
1129     # Functions called:
1130     # - die - Print to stderr and exit.
1131     # - ansible_playbook - Perform an action using ansible, see ansible.sh
1132
1133     set -xo pipefail
1134     set +eu  # We do not want to exit early in a "teardown" function.
1135     trap - EXIT || echo "Trap deactivation failed, continuing anyway."
1136     wt="${WORKING_TOPOLOGY}"  # Just to avoid too long lines.
1137     if [[ -z "${wt-}" ]]; then
1138         set -eu
1139         warn "Testbed looks unreserved already. Trap removal failed before?"
1140     else
1141         ansible_playbook "cleanup" || true
1142         python3 "${PYTHON_SCRIPTS_DIR}/topo_reservation.py" -c -t "${wt}" || {
1143             die "${1:-FAILED TO UNRESERVE, FIX MANUALLY.}" 2
1144         }
1145         WORKING_TOPOLOGY=""
1146         set -eu
1147     fi
1148 }
1149
1150
1151 function warn () {
1152
1153     # Print the message to standard error.
1154     #
1155     # Arguments:
1156     # - ${@} - The text of the message.
1157
1158     set -exuo pipefail
1159
1160     echo "$@" >&2
1161 }